/*
'License:   GPL
'Copyright: 2005 iDefense a Verisign Company
'Site:      http://labs.idefense.com
'
'Author:    David Zimmer <david@idefense.com, dzzie@yahoo.com>
'
'         This program is free software; you can redistribute it and/or modify it
'         under the terms of the GNU General Public License as published by the Free
'         Software Foundation; either version 2 of the License, or (at your option)
'         any later version.
'
'         This program is distributed in the hope that it will be useful, but WITHOUT
'         ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
'         FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for
'         more details.
'
'         You should have received a copy of the GNU General Public License along with
'         this program; if not, write to the Free Software Foundation, Inc., 59 Temple
'         Place, Suite 330, Boston, MA 02111-1307 USA
*/

#define _WIN32_WINNT 0x0401  //for IsDebuggerPresent 
#include <windows.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <stdarg.h>
#include <wininet.h>
//#include <Winsock2.h>
#include <tlhelp32.h>

#pragma warning(disable:4996)
#pragma comment(lib, "Wininet.lib")
void InstallHooks(void);

 FILE* logFile = 0;

#include "NtHookEngine.h"
#include "main.h"   //contains a bunch of library functions in it too..


bool Installed =false;

void Closing(void){ msg("***** Injected Process Terminated *****"); exit(0);}
	
extern "C" __declspec (dllexport) int NullSub(void){ return 1;}

//Config options..these must all default to 0 because default windProc response = 0 if unhandled by client..
int noSleep = 0;
int noRegistry = 0;
int blockOpenProcess = 0;
int noGetProc = 0;
int queryGetTick = 0;
int blockDebugControl = 0;
int ignoreExitProcess = 0;
int myPID = 0;

BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{

    if(!Installed){
		 Installed=true;
		 InstallHooks(); 
		 atexit(Closing);
	}

	return TRUE;
}



//___________________________________________________hook implementations _________

/*
NTSYSAPI PVOID RtlAllocateHeap(
  [in]           PVOID  HeapHandle,
  [in, optional] ULONG  Flags,
  [in]           SIZE_T Size
);

//this one was a targeted DLL IAT hook 
extern "C" __declspec (dllexport) 
PVOID __stdcall My_HeapAlloc( VOID *HeapHandle, ULONG Flags, SIZE_T Length)
{
	
		PVOID ret = HeapAlloc(HeapHandle, Flags, Length);
		if(ret != 0 && Flags != HEAP_ZERO_MEMORY){
			memset(ret, 'Z',Length);
		}

		//LogAPI("%x     HeapAlloc(addr=%x, sz=%x)", CalledFrom(),ret, Length);

		return ret;
}*/

extern "C" __declspec (dllexport) 
PVOID __stdcall My_RtlAllocateHeap( VOID *HeapHandle, ULONG Flags, SIZE_T Length)
{
	
		PVOID ret = Real_RtlAllocateHeap(HeapHandle, Flags, Length);
		if(ret != 0 && Flags != HEAP_ZERO_MEMORY){
			memset(ret, 'Z',Length);
		}

		return ret;
}

/*
LPVOID VirtualAlloc(
  [in, optional] LPVOID lpAddress,
  [in]           SIZE_T dwSize,
  [in]           DWORD  flAllocationType,
  [in]           DWORD  flProtect
);

extern "C" __declspec (dllexport) 
LPVOID __stdcall My_VirtualAlloc(LPVOID lpAddress, SIZE_T dwSize,DWORD   flAllocationType, DWORD  flProtect)
{
	
		LPVOID ret = VirtualAlloc(lpAddress, dwSize, flAllocationType, flProtect);
		if(ret != 0){
			memset(ret, 'Z',dwSize);
		}

		return ret;
}*/



//_______________________________________________ install hooks fx 

bool InstallHook( void* real, void* hook, int* thunk, char* name, enum hookType ht){
	if( HookFunction((ULONG_PTR) real, (ULONG_PTR)hook, name, ht) ){ 
		*thunk = (int)GetOriginalFunction((ULONG_PTR) hook);
		return true;
	}
	return false;
}

HMODULE hKernelBase = 0;

void DoHook(void* real, void* hook, int* thunk, char* name){

	void *lpReal = 0;
	
	if(hKernelBase != 0){//its Vista+, see if the export exists there if its in both, 
		//if(Real_GetProcAddress == NULL){
			lpReal = (void*)GetProcAddress(hKernelBase, name); //k32 is just a forwarder which we cant hook...
		//}else{
		//	lpReal = (void*)Real_GetProcAddress(hKernelBase, name); 
		//}
	}
	
	if(lpReal == 0) lpReal = real;

	if(!InstallHook( lpReal, hook, thunk, name, ht_auto ) ){
		LogAPI("Install %s hook failed...\r\nError: %s\r\n", name, GetHookError());
	}

	 
}



//Macro wrapper to build DoHook() call
#define ADDHOOK(name) DoHook( name, My_##name, (int*)&Real_##name, #name );
	
 
void HookEngineDebugMessage(char* msg){
	LogAPI("Debug> %s", msg);
}

void InstallHooks(void)
{

	DWORD dwOldProtect = 0;
	DWORD dwBuf = 0;	// nessary othewrise the function fails
	int addr = 0;
    HANDLE hMod;
	void* real;


	logLevel = 0;
	debugMsgHandler = HookEngineDebugMessage;

	myPID = GetCurrentProcessId();
	msg("***** Installing RtlFillMemory Hooks *****");	
	
    //ok so lets just manually hook IAT of target dll so its locallized...for this one test..
	
	//vba6.dll HeapAlloc does not do the trick..
	/*addr = 0xFA9141C; 
	hMod = GetModuleHandle("vba6.dll");
	if((int)hMod!=0xFA90000){
		MessageBox(0,"vba6 module base not as expected!","",0);	
	}

	// VB6 Address=0040136C Base=00400000
    addr = 0x0040136C; //vb6.exe HeapAlloc only gets lpProject name
	hMod = GetModuleHandle("vb6.exe");
	if((int)hMod!=0x0400000){
		MessageBox(0,"vb6.exe base not as expected!","",0);	
	}
		
	VirtualProtect((void*)addr, 4 , PAGE_EXECUTE_READWRITE, &dwOldProtect);
	
	int my_func = (int)My_HeapAlloc;

	_asm{
		mov eax, addr
		mov ebx, my_func
		mov [eax], ebx
	}
	
	MessageBox(0,"IAT Patched","",0);	
		
	//VirtualProtect(pCur - minPreAlign, JUMP_WORST, dwOldProtect, &dwBuf);
	return;*/

	//DO NOT HOOK GetProcAddress or GetModuleHandle we use them below (not in hook engine)..
	//hKernelBase = GetModuleHandle("kernelbase.dll");

	//void* real = GetProcAddress( GetModuleHandleA("ntdll.dll") , "RtlFillMemory");
	/*if (real==0 || !InstallHook( real, My_RtlFillMemory, (int*)&Real_RtlFillMemory,"RtlFillMemory", ht_jmp ) ){ 
		msg("Install hook RtlFillMemory failed...Error: \r\n");
	}*/

	//RtlAllocateHeap: dont do any allocs (printf) in hook or earn a recursive stack overflow 
    //real = GetProcAddress( GetModuleHandleA("kernel32.dll") , "HeapAlloc");
	real = GetProcAddress(GetModuleHandleA("ntdll.dll") , "RtlAllocateHeap");  
    if (real==0 || !InstallHook( real, My_RtlAllocateHeap, (int*)&Real_RtlAllocateHeap,"RtlAllocateHeap", ht_jmp ) ){ 
		msg("Install hook RtlAllocateHeap failed...Error: \r\n");
	}
	 
	
	
}
